 /**
 * The Fraction specification.
 * 
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 * 
 * @author Gloss
 * @version 1.0 - 23/Nov/2012
 **/
 
specification

  sorts
    Fraction

  constructors
    make:       int int -->? Fraction;

  observers
    num:        Fraction --> int;
    den:        Fraction --> int;

  others
    mult:       Fraction Fraction -->? Fraction;
    sum:        Fraction Fraction --> Fraction;
    equivalent: Fraction Fraction;
    inverse:    Fraction -->? Fraction;
    div:        Fraction Fraction -->? Fraction;

  domains
    F,G: Fraction;
    N, D: int;

    make (N, D)  if not (D = 0);
    inverse(F)   if not (num(F) = 0);
    div(F,G)     if num(G) != 0;

  axioms
    F, G: Fraction;
    N, D: int;

    num(make (N, D)) 	= N;                                       // ax 1
    den(make (N, D)) 	= D;                                       // ax 2

    mult(F, G)          = make (num(F) * num(G), den(F) * den(G)); // ax 3
    equivalent(F, G)    iff (num(F) * den(G) = num(G) * den(F));   // ax 4

    inverse(F)          = make(den(F), num(F));                    // ax 5
    div(F,G)            = make(num(F)*den(G), num(G)*den(F));      // ax 6

    sum(F,G)            = make(num(F)*den(G) + num(G)*den(F), den(F)*den(G)); // ax 7

end specification
